#include "unit.h"
#include "unitList.h"
#include "badMojoUnit.h"
#include "allegro.h"
#include "dataObj.h"
#include "gameConstants.h"
#include "tasmMath.h"

#include <vector>
using namespace std;

badMojoUnit :: badMojoUnit ()
{
}

void badMojoUnit :: init (int param1, int param2, int param3)
{
  unitCursorAngle = itofix (0);
  hitPoints = 1;
  maxHP = 1;
  timeToLive = 120;
  moveSpeed = itofix (5);
  setAffiliation (affiliationEnemy);
  diesWhenHitsAnything = true;
  hpToGivePlayer = 50;
}

void badMojoUnit :: processInput (dataObj * dO, unitList * units)
{
  //it should aim and chase the player.
  //first, get the player.

  fixed unitDist = itofix (0);
  vector <unit *> * gub = units -> search (units -> getUnits (), searchByAffiliation, affiliationPlayer);

  if (currentActivity == charStatusDead || currentActivity == charStatusStun)
    return;
    
  moveMag = 4;

  if (gub -> size () > 0)
    {
      unitCursorAngle = calcAngle (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY (), moveAngle);

      unitDist = calcDist (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY ());

      if (unitDist < itofix (150))
	moveMag = 2;
    }

  moveAngle = unitCursorAngle;
  drawAngle = unitCursorAngle;
}

badMojoUnit :: ~badMojoUnit ()
{

}
