#include "unitList.h"
#include "poleonCircleUnit.h"

#include "allegro.h"
#include "dataObj.h"
#include "unit.h"
#include "gameConstants.h"

#include <vector>
using namespace std;

poleonCircleUnit :: poleonCircleUnit ()
{

}

void poleonCircleUnit :: init (int param1, int param2, int param3)
{
  hpToGivePlayer = 0;
  poleonCirclePos = 0;
  moveSpeed = itofix (20);
  moveType = moveTypeStuckToOwner;
  hitPoints = 2000;
  maxHP = 1000;
  timeToLive = 120;
  immuneToAilments = true;
  ignoreWall = true;
  affiliation = affiliationNeutral;
}

void poleonCircleUnit :: processInput (dataObj * dO, unitList * units)
{
  vector <unit*> * gub = NULL;
  int numPC = 0;
  gub = units -> search (units -> getUnits (), searchByUnitType, unitPoleonCircle);
  gub = units -> search (gub, searchByOwner, unitPoleon);
  numPC = gub -> size ();

  if (numPC == 1)
    {
      if (unitID == gub -> at (0) -> getUnitID ())
	poleonCirclePos = (poleonCirclePos + 4) ^ 256;
    }
  else if (numPC == 2)
    {
      if (unitID == gub -> at (0) -> getUnitID ())
	poleonCirclePos = (poleonCirclePos + 4) ^ 256;
      if (unitID == gub -> at (1) -> getUnitID ())
	poleonCirclePos = (static_cast <poleonCircleUnit *>(gub -> at (0)) -> poleonCirclePos + 128) ^ 256;
    }
  else if (numPC == 3)
    {
      if (unitID == gub -> at (0) -> getUnitID ())
	poleonCirclePos = (poleonCirclePos + 4) ^ 256;
      if (unitID == gub -> at (1) -> getUnitID ())
	poleonCirclePos = (static_cast <poleonCircleUnit *>(gub -> at (0)) -> poleonCirclePos + 85) ^ 256;
      if (unitID == gub -> at (2) -> getUnitID ())
	poleonCirclePos = (static_cast <poleonCircleUnit *>(gub -> at (0)) -> poleonCirclePos + 170) ^ 256;
    }
  drawAngle = itofix ((-poleonCirclePos) ^ 256);
  offsetX = fixmul (itofix (50), fixsin (itofix (poleonCirclePos)));
  offsetY = fixmul (itofix (50), fixcos (itofix (poleonCirclePos)));
}

poleonCircleUnit :: ~poleonCircleUnit ()
{

}
