#ifndef _DATAOBJ_H_
#define _DATAOBJ_H_

#include "allegro.h"
#include "videoSettings.h"
#include "inputObj.h"
#include "arena.h"
#include <vector>
using namespace std;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
class dataObj {

 public:
  dataObj ();

  void readConfig ();
  void saveConfig ();

  videoSettings * getVideoSettings ();
  int setVideoSettings (videoSettings *);

  inputObj * getInputObj ();
  int setInputObj (inputObj *);

  arena * getArena ();
  int setArena (arena *);

  DATAFILE * getDatafile ();
  DATAFILE * setDatafile (const char *);

  int getFirstRoundOfCampaign ();
  void setFirstRoundOfCampaign (int);
  int getCharID ();
  void setCharID (int);
  int getCampaignID ();
  void setCampaignID (int);

  ~dataObj ();

 protected:
  DATAFILE * picData;  //datafile (allegro term for data, music, pics) settings
  videoSettings * vS;
  arena * aren;
  inputObj * inpObj;
  int firstRoundOfCampaign;
  int charID;
  int campaignID;
};

//////////////////////////////////////////  END OF dataObj
#endif
