#include "unit.h"
#include "unitList.h"
#include "homa.h"
#include "allegro.h"
#include "dataObj.h"
#include "gameConstants.h"
#include "tasmMath.h"

#include <vector>
using namespace std;

homa :: homa ()
{
}

void homa :: init (int param1, int param2, int param3)
{
  unitCursorAngle = itofix (rand () % 256);
  aimTimeMax = 60;
  rushTimeMax = 60;
  homingTimer = 0;
  rushing = false;
  
  statusAilment -> at (statusAilmentInvic) = 5;

  hitPoints = 1000;
  maxHP = 1000;
  moveSpeed = itofix (2);
  
  if (param3 == 1)
    {
      //create uber homer!
      hitPoints = 5000;
      maxHP = 5000;
      moveSpeed = ftofix (10);
      drawScale = ftofix (2.0);
      hb -> damageDealt = 750;
      immuneToAilments = true;
      drawHPBar = true;
    }

  wantsToTaunt = true;
      
  aimTimeMax = param1;
  rushTimeMax = param2;

  homingTimer = aimTimeMax;
  setAffiliation (affiliationEnemy);
}

void homa :: processInput (dataObj * dO, unitList * units)
{
  //it should aim and chase the player.
  //first, get the player.

  vector <unit *> * gub = units -> search (units -> getUnits (), searchByAffiliation, affiliationPlayer);

  //if OK...

  if (currentActivity == charStatusDead || currentActivity == charStatusStun)
    return;

  if (!rushing)
    {
      moveMag = 0;
      if (gub -> size () > 0)
	unitCursorAngle = calcAngle (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY (), moveAngle);
    }
  
  if (rushing)
    {
      moveMag = 4;
    }
  
  homingTimer--;
  
  if (homingTimer <= 0 && rushing)
    {
      homingTimer = aimTimeMax;
      rushing = !rushing;
    }
  
  if (homingTimer <= 0 && !rushing)
    {
      homingTimer = rushTimeMax;
      rushing = !rushing;
    }
  moveAngle = unitCursorAngle;
  drawAngle = unitCursorAngle;
}

homa :: ~homa ()
{

}
